#include	<stdio.h>

FILE *fpin, *fpout;
char INIFILE[] = "ff8cdadr.ini";
unsigned char buff[256];
unsigned long address=0;

/* number of images */
#define DISC1IMG	31
#define DISC2IMG	34
#define DISC3IMG	32
#define DISC4IMG	7

/* offset address */
unsigned long disc1adr[DISC1IMG];
unsigned long disc2adr[DISC2IMG];
unsigned long disc3adr[DISC3IMG];
unsigned long disc4adr[DISC4IMG];
/* frames */
unsigned int disc1len[DISC1IMG];
unsigned int disc2len[DISC2IMG];
unsigned int disc3len[DISC3IMG];
unsigned int disc4len[DISC4IMG];
unsigned int discimg[4] = {
	DISC1IMG, DISC2IMG, DISC3IMG, DISC4IMG
};
unsigned long *discadr[4] = {
	disc1adr, disc2adr, disc3adr, disc4adr
};
unsigned int *disclen[4] = {
	disc1len, disc2len, disc3len, disc4len
};

void printCopyright( void )
{
	printf("\nCopyright (C) 1999 Koujin's\n");
	printf("http://www02.so-net.ne.jp/~koujin\n\n");
}

void printUsage( void )
{
	printCopyright();
	printf("USAGE:ff8cdfnd D:ff8disc?.img\n");
}

int discID=0;

void decodeDiscID( char *str ){
	int a, i;

	for(i=0;i<256;i++) if(str[i]=='\0') break;
	if( strncmp( str+i-12, "ff8disc", 7 ) != 0 ){
		printUsage();
		exit(0);
	}
	if( strncmp( str+i-4, ".img", 4 ) != 0 ){
		printUsage();
		exit(0);
	}
	sscanf(str+i-12, "ff8disc%d.img", &a);
	discID = a;
}

int mystrncmp( unsigned char *str1, unsigned char *str2, int len )
{
	int i;

	for(i=0;i<len;i++){
		if(str1[i]!=str2[i]) return -1;
	}
	return 0;
}

unsigned char pattern0[8] = "SMN\1\0\x9\0\0";
unsigned char pattern1[8] = "SMR\1\1\x9\0\0";
unsigned char pattern2[8] = "SMJ\1\2\x9\0\0";

void searchImg( char *str ){
	int i;
	int id=0;
	unsigned int frame;
	unsigned long findaddress;

	if( ( fpin = fopen( str, "rb" ) ) == NULL ){
		printf("cannot open file %s\n", str );
		return;
	}
	printf("Now searching... %s\n",str);
//fseek( fpin, 0x12000000, 0 );
//address = 0x12000000;
	while(1){
NEXTTRY:
		for(i=0;i<7;i++) buff[i]=buff[i+1];
		buff[7]=getc(fpin);
		address++;
		if( mystrncmp( buff, pattern0, 8 ) == 0 ){
NEXTMOVIE:
			for(i=0x7F8;i>0;i--)getc(fpin);
			for(i=0;i<8;i++) buff[i]=getc(fpin);
			address+=0x800;
			if( mystrncmp( buff, pattern1, 8 ) == 0 ){
				for(i=0x7F8;i>0;i--)getc(fpin);
				for(i=0;i<8;i++) buff[i]=getc(fpin);
				address+=0x800;
				if( mystrncmp( buff, pattern2, 8 ) == 0 ){
					findaddress = address-0x1008;
//					printf("Found! %d: 0x%08lX\n", id, findaddress );
					for(i=0x3FF8;i>0;i--)getc(fpin);
					address+=0x3FF8;
					frame=1;
					printf("\n");
NEXTFRAME:
					if(feof(fpin)!=0){
						discadr[discID-1][id] = findaddress;
						disclen[discID-1][id] = frame;
						printf(" Found! ID=%d: 0x%08lX, 0x%X frame", id++, findaddress, frame );
						goto END;
					}
					for(i=0;i<8;i++) buff[i]=getc(fpin);
					address+=0x8;
					if( mystrncmp( buff, pattern0, 8 ) == 0 ){
						discadr[discID-1][id] = findaddress;
						disclen[discID-1][id] = frame;
						printf(" Found! ID=%d: 0x%08lX, 0x%X frame", id++, findaddress, frame );
						goto NEXTMOVIE;
					}else
					if( mystrncmp( buff, pattern0, 6 ) == 0 ){
						frame++;
						if((frame&0xF)==0) printf("*");
						if((frame&0x1FF)==0) printf("\n");
						for(i=0x4FF8;i>0;i--)getc(fpin);
						address+=0x4FF8;
						goto NEXTFRAME;
					}else{
						discadr[discID-1][id] = findaddress;
						disclen[discID-1][id] = frame;
						printf(" Found! ID=%d: 0x%08lX, 0x%X frame", id++, findaddress, frame );
						goto NEXTTRY;
					}
		}	}	}
		if((address&0x7FFFF)==0)printf(".");
		if((address&0xFFFFFF)==0){
			printf("0x%08lX\n",address);
		}
		if(feof(fpin)!=0) break;
	}
END:
	printf("\n");
	fclose( fpin );
}

void valini( void )
{
	int i, j;
	unsigned long adr;
	unsigned int len;
	int id;

	for(i=0;i<4;i++) for(j=0;j<discimg[i];j++) {
		discadr[i][j]=0L;
		disclen[i][j]=0;
	}
	if( ( fpin = fopen( INIFILE, "r" ) ) == NULL ){
		printf("file %s is not exist\n", INIFILE );
		return;
	}
	while(1){	// read ini file
		fgets( buff, 256, fpin );
		if( strncmp( buff, "[ff8disc", 8 ) == 0 ){
			sscanf( buff, "[ff8disc%d.img]", &discID);
		}else if( strncmp( buff, "id=", 3 ) == 0 ){
			sscanf( buff, "id=%d, address=0x%08lX, frame=0x%04X", &id, &adr, &len );
			if((1<=discID)&&(discID<=4)){
				if((0<=id)&&(id<=discimg[discID-1])){
					discadr[discID-1][id] = adr;
					disclen[discID-1][id] = len;
		}	}	}
		if(feof(fpin)!=0) break;
	}
	fclose( fpin );
}

void writeini( void )
{
	int i,j;

	if( ( fpout = fopen( INIFILE, "w" ) ) == NULL ){
		printf("cannot open file %s\n", INIFILE );
		return;
	}
	printf("write %s file\n",INIFILE);
	fprintf( fpout, "[Final Fantasy VIII CD-ROM movie address information]\n");
	for(i=0;i<4;i++) {
		fprintf( fpout, "[ff8disc%d.img]\n", i+1 );
		for(j=0;j<discimg[i];j++) {
			if(disclen[i][j]) fprintf( fpout, "id=%d, address=0x%08lX, frame=0x%04X\n",
				j, discadr[i][j], disclen[i][j] );
	}	}
	fclose( fpout );
}

void main( int argc, char ** argv ){
	int i,j;

	if( argc < 2 ){
		printUsage();
		exit(0);
	}
	valini();
	decodeDiscID( argv[1] );
	searchImg( argv[1] );
	writeini();
}
